# ---------------------------------
# Finds QT
# Adds library to target
# Adds include path
# ---------------------------------
IF(WIN32)
	FIND_PATH(PATH_QT  QtCore/qglobal.h PATHS "C:\QtSDK\Desktop\Qt\4.7.4\msvc2008\include/"  $ENV{OpenViBE_dependencies})
	IF(PATH_QT)
		MESSAGE(STATUS "  Found QT...")
		INCLUDE_DIRECTORIES(${PATH_QT})
		ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyQT)
		
		# Copying the DLL file at postbuild

		ADD_CUSTOM_COMMAND(
				TARGET ${PROJECT_NAME}-dynamic
				POST_BUILD
				COMMAND ${CMAKE_COMMAND}
				ARGS -E copy "${PATH_QT}/../lib/QtCore4.dll" "${PROJECT_SOURCE_DIR}/bin"
				COMMENT "      --->   Copying dll file ${PATH_QT}/../lib/QtCore4.dll for the QT."
			VERBATIM)	
	ELSE(PATH_QT)
		MESSAGE(STATUS "  FAILED to find QT - cmake looked in 'C:\QtSDK\Desktop\Qt\4.7.4\msvc2008\include/' and '$ENV{OpenViBE_dependencies}'")
	ENDIF(PATH_QT)
ENDIF(WIN32)

IF(UNIX)
	MESSAGE(STATUS "The QT is only available on windows.")
ENDIF(UNIX)
