# ---------------------------------
# Finds STARLAB ENOBIO library
# Adds library to target
# Adds include path
# ---------------------------------
IF(WIN32)
	FIND_PATH(PATH_ENOBIOAPI Enobio.h PATHS "C:/enobio_api/shared/"  $ENV{OpenViBE_dependencies})
	IF(PATH_ENOBIOAPI)
		MESSAGE(STATUS "  Found ENOBIO API...")
		INCLUDE_DIRECTORIES(${PATH_ENOBIOAPI})
		INCLUDE_DIRECTORIES("$(PATH_ENOBIOAPI)/../interfaces/")
		FIND_LIBRARY(LIB_ENOBIOAPI EnobioAPI PATHS ${PATH_ENOBIOAPI} )
		IF(LIB_ENOBIOAPI)
			MESSAGE(STATUS "    [  OK  ] lib ${LIB_ENOBIOAPI}")
			TARGET_LINK_LIBRARIES(${PROJECT_NAME}-dynamic ${LIB_ENOBIOAPI} )
		ELSE(LIB_ENOBIOAPI)
			MESSAGE(STATUS "    [FAILED] lib ENOBIO")
		ENDIF(LIB_ENOBIOAPI)

		ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyEnobioAPI)
		
		# Copying the DLL file at postbuild
		ADD_CUSTOM_COMMAND(
				TARGET ${PROJECT_NAME}-dynamic
				POST_BUILD
				COMMAND ${CMAKE_COMMAND}
				ARGS -E copy "${PATH_ENOBIOAPI}/EnobioAPI.lib" "${PROJECT_SOURCE_DIR}/bin"
				COMMENT "      --->   Copying dll file ${PATH_ENOBIOAPI}/EnobioAPI.lib for the STARLAB Enobio driver."
			VERBATIM)
	ELSE(PATH_ENOBIOAPI)
		MESSAGE(STATUS "  FAILED to find ENOBIO API - cmake looked in 'C:/enobio_api/shared/' and '$ENV{OpenViBE_dependencies}'")
	ENDIF(PATH_ENOBIOAPI)
ENDIF(WIN32)

IF(UNIX)
	MESSAGE(STATUS "The ENOBIO API is only available on windows.")
ENDIF(UNIX)
