#ifndef DEFAULTDATAPRODUCER_H
#define DEFAULTDATAPRODUCER_H

#include "../interfaces/IDataProducer.h"
#include <vector>

/*!
 * \typedef vector<IDataConsumer const *> PTRDATACONSUMERVECTOR
 *
 * \brief Vector of pointerts to data consumer objects
 */
typedef std::vector<IDataConsumer *> PTRDATACONSUMERVECTOR;

/*!
 * \class DefaultDataProducer DefaultDataProducer.h
 *
 * \brief Default implementation of the IDataProducer interface.
 */
class DefaultDataProducer : public IDataProducer
{
public:
    /*!
     * Default constructor
     */
    DefaultDataProducer ();

    virtual ~DefaultDataProducer ();

    virtual void sendData (const PData& data);

    virtual void addDataConsumerEndPoint (IDataConsumer & dataConsumer);

    virtual void removeDataConsumerEndPoint (const IDataConsumer & dataConsumer);

private:
    PTRDATACONSUMERVECTOR dataConsumers;

};

#endif // DEFAULTDATAPRODUCER_H
