#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "..\..\SIPPProtocol.h"
#include "..\..\OffsetControl.h"
#include "..\..\FTDIDevice.h"
#include "..\..\ReaderEngine.h"
#include "..\..\EnobioData.h"
#include "..\..\Enobio.h"
#include "..\FileWriter.h"
#include "..\StatusWriter.h"
#include <QMessageBox>
#include <QFile>
#include <QTextStream>


namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Ui::MainWindow *ui;
    SIPPProtocol protocol;
    OffsetControl control;
    ReaderEngine reader;
    FTDIDevice device;
    QByteArray buffer;
    QMessageBox msgBox;
    QString str;
    QFile file;
    QTextStream out;
    QString fileName;
    FileWriter fileWriter;
    StatusWriter statusWriter;
    Enobio dataProducer;



private slots:

    void on_sippProtocolBtn_2_clicked();
    void on_filewriterBtn_clicked();
    void on_pauseBtn_clicked();
    void on_resumeBtn_clicked();
    void on_stopBtn_clicked();
    void on_startBtn_clicked();
    void on_sippProtocolBtn_clicked();
    void on_offsetControlBtn_clicked();
    void on_readerEngineBtn_clicked();
    void on_runTestBtn_clicked();
    void on_browseBtn_clicked();
    int _getVolts(int v);
    void _processSample(const unsigned char * enobioBytes,bool lostPacket);
    void doOffsetTest();
    void doProtocolTest();
    void doProtocolTest2();
    void doFileWritingTest();
};

#endif // MAINWINDOW_H
