#include "ovasCEnobioDataConsumer.h"
#if defined TARGET_HAS_ThirdPartyEnobioAPI

const int buffer_length=500;

CEnobioDataConsumer::CEnobioDataConsumer(){
	clearBuffer();
}
CEnobioDataConsumer::~CEnobioDataConsumer(){
}
void CEnobioDataConsumer::receiveData( const PData &data) {
	int *newdata;
	EnobioData* e;
	if(current_length>buffer_length){
		//todo error handle
	}else{
		//parse data from ENOBIO
		e= (EnobioData*) data.getData();
		newdata = (int*) malloc(sizeof(int)*4);
		newdata[0]=e->getChannel1();
		newdata[1]=e->getChannel2();
		newdata[2]=e->getChannel3();
		newdata[3]=e->getChannel4();
		data_queue.push(newdata);
		current_length++;
	}
}
int CEnobioDataConsumer::consumeData(OpenViBE::float32* buffer,int size,int count){
	while(!data_queue.empty()&&count<size){
			int* e=data_queue.front();
			buffer[count]=(OpenViBE::float32)e[0]; //channel1
			buffer[size+count]=(OpenViBE::float32)e[1]; //channel2
			buffer[size*2+count]=(OpenViBE::float32)e[2]; //channel3
			buffer[size*3+count]=(OpenViBE::float32)e[3]; //channel4
			count++;
			data_queue.pop();
			free(e);
			current_length--;
	}
	return count;
}
void CEnobioDataConsumer::clearBuffer(){
	while(!data_queue.empty()){
		int* e=data_queue.front();
		data_queue.pop();
		free(e);
	}
	current_length=0;
}
#endif // TARGET_HAS_ThirdPartyEnobioAPI