#include "ovasCEnobioStatusConsumer.h"


using namespace std;
#if defined TARGET_HAS_ThirdPartyEnobioAPI

CEnobioStatusConsumer::CEnobioStatusConsumer(){
	clearBuffer();
}
CEnobioStatusConsumer::~CEnobioStatusConsumer(){
}
void CEnobioStatusConsumer::receiveData(const PData &data) {
	StatusData* newdata=(StatusData*)data.getData();
	string stateType=StatusData::getTypeFromCode(newdata->getCode());

	string message=StatusData::getStringFromCode(newdata->getCode());
	if(stateType.compare("ERROR")==0){
		//error status
		error_queue.push(newdata->getCode());
	}else{
		//other status
		info_queue.push(newdata->getCode());
	}

}
int CEnobioStatusConsumer::consumeErrorData(StatusData::statusCode *buffer){	
	int count=0;
	while(!error_queue.empty()){
		StatusData::statusCode e=error_queue.front();
		buffer[count]=e;
		count++;
		error_queue.pop();
		current_error_length--;
	}
	return count;
}
int CEnobioStatusConsumer::consumeInfoData(StatusData::statusCode *buffer){
	int count=0;
	while(!info_queue.empty()){
		StatusData::statusCode e=info_queue.front();
		buffer[count]=e;
		count++;
		info_queue.pop();
		current_info_length--;
	}
	return count;
}

void CEnobioStatusConsumer::clearBuffer(){	
	while(!error_queue.empty()){
		error_queue.pop();
	}
	while(!info_queue.empty()){
		info_queue.pop();
	}
	current_info_length=0;
	current_error_length=0;
}
#endif // TARGET_HAS_ThirdPartyEnobioAPI
